OpenTTD: VehicleListWindow Struct Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Private Types
VehicleListWindow Struct Reference

Window for the (old) vehicle listing. More...

Inheritance diagram for VehicleListWindow:

## Public Member Functions
| VehicleListWindow (WindowDesc *desc, WindowNumber window_number)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnTick ()
| Called once per (game) tick.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
Public Member Functions inherited from BaseVehicleListWindow
| BaseVehicleListWindow (WindowDesc *desc, WindowNumber wno)
void | DrawVehicleListItems (VehicleID selected_vehicle, int line_height, const Rect &r) const
| Draw all the vehicle list items.
void | SortVehicleList ()
void | BuildVehicleList ()
Dimension | GetActionDropdownSize (bool show_autoreplace, bool show_group)
| Compute the size for the Action dropdown.
DropDownList * | BuildActionDropdownList (bool show_autoreplace, bool show_group)
| Display the Action dropdown window.
Public Member Functions inherited from Window
| Window (WindowDesc *desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
void * | operator new[] (size_t size)
| Helper allocation function to disallow something.
void | operator delete (void *ptr)
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (uint widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
template<class NWID >
NWID * | GetWidget (uint widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (uint widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (uint widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (uint widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (uint widnum)
| Return the querystring associated to a editbox.
virtual const char * | GetFocusedText () const
| Get the current input text if an edit box has the focus.
virtual const char * | GetCaret () const
| Get the string at the caret if an edit box has the focus.
virtual const char * | GetMarkedText (size_t *length) const
| Get the range of the currently marked input text.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual const char * | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree (bool fill_nested=true)
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (byte widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (byte widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (byte widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (byte widget_index)
| Sets a widget to disabled.
void | EnableWidget (byte widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (byte widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (byte widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (byte widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (byte widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (byte widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (byte widget_index)
| Marks a widget as lowered.
void | RaiseWidget (byte widget_index)
| Marks a widget as raised.
bool | IsWidgetLowered (byte widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (int widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (int wid, WChar key, uint16 keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (int wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (byte widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, int widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
void CDECL | SetWidgetsDisabledState (bool disab_stat, int widgets,...)
| Sets the enabled/disabled status of a list of widgets.
void CDECL | SetWidgetsLoweredState (bool lowered_stat, int widgets,...)
| Sets the lowered/raised status of a list of widgets.
void | SetWidgetDirty (byte widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (int widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
void | DeleteChildWindows (WindowClass wc=WC_INVALID) const
| Delete all children a window might have in a head-recursive manner.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16 sm_width, int16 sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnFocus ()
| Called when window gains focus.
virtual void | OnFocusLost ()
| Called when window looses focus.
virtual EventState | OnKeyPress (WChar key, uint16 keycode)
| A key has been pressed.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, int widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, int widget)
| The mouse is hovering over a widget in the window, perform an action for it, like opening a custom tooltip.
virtual void | OnMouseDrag (Point pt, int widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnDragDrop (Point pt, int widget)
| A dragged 'object' has been released.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnMouseOver (Point pt, int widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnHundredthTick ()
| Called once every 100 (game) ticks.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownClose (Point pt, int widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnEditboxChanged (int widget)
| The text in an editbox has been edited.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Private Types
enum | ButtonPlanes { BP_SHOW_BUTTONS, BP_HIDE_BUTTONS }
| Enumeration of planes of the button row at the bottom. More...

## Additional Inherited Members
Public Types inherited from BaseVehicleListWindow
enum | ActionDropdownItem { ADI_REPLACE, ADI_SERVICE, ADI_DEPOT, ADI_ADD_SHARED, ADI_REMOVE_ALL }
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
Data Fields inherited from BaseVehicleListWindow
GUIVehicleList | vehicles
| The list of vehicles.
Listing * | sorting
| Pointer to the vehicle type related sorting.
byte | unitnumber_digits
| The number of digits of the highest unit number.
Scrollbar * | vscroll
VehicleListIdentifier | vli
| Identifier of the vehicle list we want to currently show.
Static Public Attributes inherited from BaseVehicleListWindow
static const StringID | vehicle_depot_name []
static const StringID | vehicle_sorter_names []
static GUIVehicleList::SortFunction *const | vehicle_sorter_funcs []
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size.
Protected Attributes inherited from Window
SmallVector< int, 4 > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.

## Detailed Description

Window for the (old) vehicle listing.

bitmask for w->window_number 0-7 CompanyID (owner) 8-10 window type (use flags in vehicle_gui.h) 11-15 vehicle type (using VEH_, but can be compressed to fewer bytes if needed) 16-31 StationID or OrderID depending on window type (bit 8-10)

Definition at line 1431 of file vehicle_gui.cpp.

## Member Enumeration Documentation

enum VehicleListWindow::ButtonPlanes
| private

Enumeration of planes of the button row at the bottom.

Enumerator:

  BP_SHOW_BUTTONS | Show the buttons.
  BP_HIDE_BUTTONS | Show the empty panel.

Definition at line 1434 of file vehicle_gui.cpp.

## Member Function Documentation

virtual void VehicleListWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget
| ) |  | const
| inlinevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1561 of file vehicle_gui.cpp.

References Window::DrawSortButtonState(), BaseVehicleListWindow::DrawVehicleListItems(), INVALID_VEHICLE, GUIList< T, F >::IsDescSortOrder(), Window::resize, SBS_DOWN, SBS_UP, ResizeInfo::step_height, BaseVehicleListWindow::vehicles, WID_VL_LIST, and WID_VL_SORT_ORDER.

virtual void VehicleListWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count
| ) |  |
| inlinevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1607 of file vehicle_gui.cpp.

References BaseVehicleListWindow::BuildActionDropdownList(), CMD_MASS_START_STOP, DoCommandP(), Scrollbar::GetScrolledRowFromWidget(), INVALID_TILE, SmallVector< T, S >::Length(), Window::SetDirty(), ShowDropDownList(), ShowDropDownMenu(), ShowVehicleViewWindow(), GUIList< T, F >::SortType(), GUIList< T, F >::ToggleSortOrder(), VEH_ROAD, VEH_TRAIN, VehicleClicked(), BaseVehicleListWindow::vehicles, BaseVehicleListWindow::vli, VehicleListIdentifier::vtype, WID_VL_AVAILABLE_VEHICLES, WID_VL_LIST, WID_VL_MANAGE_VEHICLES_DROPDOWN, WID_VL_SORT_BY_PULLDOWN, WID_VL_SORT_ORDER, WID_VL_START_ALL, and WID_VL_STOP_ALL.

virtual void VehicleListWindow::OnDropdownSelect | ( | int | widget,
|  | int | index
| ) |  |
| inlinevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 1646 of file vehicle_gui.cpp.

References ALL_GROUP, DEPOT_MASS_SEND, DEPOT_SERVICE, DoCommandP(), SmallVector< T, S >::Length(), Window::SetDirty(), GUIList< T, F >::SetSortType(), ShowReplaceGroupVehicleWindow(), BaseVehicleListWindow::vehicles, BaseVehicleListWindow::vli, VehicleListIdentifier::vtype, WID_VL_MANAGE_VEHICLES_DROPDOWN, and WID_VL_SORT_BY_PULLDOWN.

virtual void VehicleListWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlinevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 1693 of file vehicle_gui.cpp.

References GUIList< T, F >::ForceRebuild(), GUIList< T, F >::ForceResort(), GB(), HasBit(), VehicleListIdentifier::index, VehicleListIdentifier::Pack(), VehicleListIdentifier::type, BaseVehicleListWindow::vehicles, and BaseVehicleListWindow::vli.

virtual void VehicleListWindow::OnPaint | ( |  | ) |
| inlinevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1575 of file vehicle_gui.cpp.

References _local_company, BP_HIDE_BUTTONS, BP_SHOW_BUTTONS, Window::DrawWidgets(), HideDropDownMenu(), Window::IsWidgetLowered(), SmallVector< T, S >::Length(), Window::owner, NWidgetBase::SetDirty(), NWidgetStacked::SetDisplayedPlane(), Window::SetWidgetDisabledState(), Window::SetWidgetsDisabledState(), NWidgetStacked::shown_plane, GUIList< T, F >::SortType(), VehicleListIdentifier::type, BaseVehicleListWindow::vehicles, BaseVehicleListWindow::vli, WID_VL_AVAILABLE_VEHICLES, WID_VL_HIDE_BUTTONS, WID_VL_MANAGE_VEHICLES_DROPDOWN, WID_VL_SORT_BY_PULLDOWN, WID_VL_START_ALL, WID_VL_STOP_ALL, and WIDGET_LIST_END.

virtual void VehicleListWindow::OnResize | ( |  | ) |
| inlinevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1683 of file vehicle_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and WID_VL_LIST.

virtual void VehicleListWindow::SetStringParameters | ( | int | widget | ) | const
| inlinevirtual

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.

Reimplemented from Window.

Definition at line 1518 of file vehicle_gui.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_station_pool >::Get(), Scrollbar::GetCount(), VehicleListIdentifier::index, SpecializedStation< Station, false >::IsExpected(), SmallVector< T, S >::Length(), SetDParam(), VehicleListIdentifier::type, BaseVehicleListWindow::vehicles, BaseVehicleListWindow::vli, VehicleListIdentifier::vtype, WID_VL_AVAILABLE_VEHICLES, and WID_VL_CAPTION.

virtual void VehicleListWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize
| ) |  |
| inlinevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  widget | Widget number.
  size | Size of the widget.
  padding | Recommended amount of space between the widget content and the widget edge.
  fill | Fill step of the widget.
  resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 1481 of file vehicle_gui.cpp.

References BaseVehicleListWindow::GetActionDropdownSize(), GetStringBoundingBox(), GetVehicleListHeight(), maxdim(), Window::SortButtonWidth(), VehicleListIdentifier::type, VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, VEH_TRAIN, BaseVehicleListWindow::vli, VehicleListIdentifier::vtype, WID_VL_LIST, WID_VL_MANAGE_VEHICLES_DROPDOWN, and WID_VL_SORT_ORDER.

The documentation for this struct was generated from the following file:

- src/vehicle_gui.cpp